#!/sbin/sh
cd /tmp/tools
#4 Get ext type if any
mmcblk0p2=`ls /dev/block/mmcblk0p2`
if [ $mmcblk0p2 == "/dev/block/mmcblk0p2" ]
then
	mkdir -p /ext4p
	busybox mkdir /sd-ext
	busybox mount -t auto /dev/block/mmcblk0p2 /sd-ext
	ext_type=`busybox mount | busybox grep "ext" | busybox cut -d ' ' -f 5`
else
	exit 1
fi
#2 Dump boot image
/tmp/tools/dump_image boot boot.img
#3 Unpack boot.img => zImage & initrd.gz
/tmp/tools/unpackbootimg boot.img /tmp/tools
#4 Extract boot.img-ramdisk
mkdir boot.img-ramdisk
cd boot.img-ramdisk
cp /tmp/tools/boot.img-ramdisk.gz boot.img-ramdisk.gz
gzip -d -c boot.img-ramdisk.gz | cpio -i -d
rm boot.img-ramdisk.gz
#5 Replace line about data mounting in init.rc
sed -i '
	/mtd@userdata/ {
	i\
	chmod 0750 /sbin/extprep
	i\
	exec /sbin/extprep
	c\
	mount '${ext_type}' /dev/block/mmcblk0p2 /data wait nosuid nodev noatime nodiratime
	}
' init.rc
#6 Copy extprep to sbin
cd sbin
cp /tmp/tools/extprep extprep
chmod 0750 extprep
#7 Rebuild initrd.gz
cd /tmp/tools/boot.img-ramdisk
find . | cpio -o -H newc | gzip -9 > initrd.gz
#8 Move it to tmp/tools
cp initrd.gz /tmp/tools/initrd.gz
rm initrd.gz
#9 Set perm
cd /tmp/tools
chmod 0777 initrd.gz
chmod 0777 *zImage
#10 Recompile boot.img
/tmp/tools/mkbootimg --kernel /tmp/tools/*zImage \
                    --ramdisk /tmp/tools/initrd.gz \
                    --cmdline "`cat $cwm_backup_path/boot.img-cmdline`" \
                    --base 0x11800000 \
                    --output /tmp/tools/boot.img
rm /tmp/tools/initrd.gz
rm -fr /tmp/tools/boot.img-*
#11 Flash boot.img
/tmp/tools/flash_image boot /tmp/tools/boot.img 
exit 0
