#!/sbin/sh
cd /tmp/tools
#1 Get ext type if any
mmcblk0p2=`ls /dev/block/mmcblk0p2`
if [ $mmcblk0p2 == "/dev/block/mmcblk0p2" ]
then
	mkdir -p /ext4p
	busybox mkdir /sd-ext
	busybox mount -t auto /dev/block/mmcblk0p2 /sd-ext
	ext_type=`busybox mount | busybox grep "ext" | busybox cut -d ' ' -f 5`
else
	exit 1
fi
#2 Extract boot.img-ramdisk
mkdir boot.img-ramdisk
cd boot.img-ramdisk
cp /boot/initrd.gz boot.img-ramdisk.gz
gzip -d -c boot.img-ramdisk.gz | cpio -i -d
rm boot.img-ramdisk.gz
#3 Replace line with /data mounting in init.rc
sed -i '
	/mtd@userdata/ {
	i\
	chmod 0750 /sbin/extprep
	i\
	exec /sbin/extprep
	c\
	mount '${ext_type}' /dev/block/mmcblk0p2 /data wait nosuid nodev noatime nodiratime
	}
' init.rc
#4 Copy extprep to sbin
cd sbin
cp /tmp/tools/extprep extprep
chmod 0750 extprep
#5 Rebuild initrd.gz
cd /tmp/tools/boot.img-ramdisk
find . | cpio -o -H newc | gzip -9 > initrd.gz
#6 Replace old one
cp initrd.gz /boot/initrd.gz
rm -f initrd.gz
rm -fr /tmp/tools/boot.img-*
cd /boot
chmod 0777 initrd.gz
exit 0
